/*	=============
 *	SiesString.hh
 *	=============
 *	
 *	Implemented by SiesString.cc
 */

#ifndef SIESSTRING_HH
#define SIESSTRING_HH

#include <Types.h>

class SiesString {
public:
	SiesString();
	SiesString(const SiesString &inString);
	SiesString(void *inData, long inLen);
	SiesString(const char *inCStr);
	SiesString(const unsigned char *inPStr);
	SiesString(Handle inHandle);
	virtual ~SiesString();
	
	virtual void Set(const void *inData, long inLen);
	virtual void Set(const SiesString &inString);
	virtual void Set(const char *inCStr);
	virtual void Set(const unsigned char *inPStr);
	virtual void Set(Handle inHandle);
	
	virtual void Append(const void *inData, long inLen);
	virtual void Append(const SiesString &inString);
	virtual void Append(const char *inCStr);
	virtual void Append(const unsigned char *inPStr);
	virtual void Append(Handle inHandle);
	
	virtual long Length() const;
	virtual long GetData(void *outData, long inLen) const;
	virtual char *GetCStr(char *outCStr, long inLen) const;
	virtual unsigned char *GetPStr(unsigned char *outPStr, short inLen) const;
	
protected:
	virtual void *Ptr() const;
	virtual void Realloc(long inSize);
	
protected:
	void *mPtr;
	long mLen;
};

#endif
